/*
 * xsk.c --- sk.c + skcache.c
 *      by k-chinen@is.aist-nara.ac.jp, 2000, 2001.
 *
 * $Id$
 */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <limits.h>
#include <pthread.h>
#include <time.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/uio.h>

#include <dirent.h>

#ifdef HAVE_MALLOC_H
#include <malloc.h>
#endif

#include <sys/mman.h>

#include <assert.h>
#include <errno.h>


#include "range.h"
#include "msg.h"
#include "misc.h"
#include "mem.h"

#include "xsk.h"
#include "sim_stat.h"
#include "sim_hist.h"
#include "mlist.h"

#ifndef MAX
#define MAX(a,b) (((a)>(b))?(a):(b))
#endif
#ifndef MIN
#define MIN(a,b) (((a)<(b))?(a):(b))
#endif

void*
kotetu_mem_alloc_lock(int len)
{
    void* ret;

    ret = malloc(len);
    if(ret!=NULL) {
        if(mlock(ret, len)<0) {
            Error("fail mlock addr %p, len %d (%d)", ret, len, errno);
        }
    }
    return ret;
}

